#include <bits/stdc++.h>
using namespace std;
int main() 
{
ios_base::sync_with_stdio(false);
cin.tie(NULL);
int t,a,b;
cin>>t;
long long prvi,nzd,kraj=0,razlika,x;
while(t>0)
{
kraj=0;
cin>>a>>b;
for(int i=0;i<a;i++)
{
cin>>x;
if(i==0)
prvi=x;
if(i>0)
{
razlika=max((x-prvi),(prvi-x));
if(i>1)
nzd=__gcd(nzd,razlika);
else
nzd=razlika;
}
}
if(nzd==1)
{
for(int i=0;i<b;i++)
cin>>x;
cout<<0<<endl;
goto end;
}
for(int i=0;i<b;i++)
{
cin>>x;
if(max((x-prvi),(prvi-x))%nzd==0)
kraj=1;
}
if(kraj==1)
cout<<0<<endl;
else
cout<<1<<endl;
end: t--;
}
return 0;
}